C     Programmer:Chris Burke
C     Date: June 9, 1997
C     Purpose: Rotate the particles to viewing angle.  Then it assign 
C     the particles to a tube.

      Subroutine assignt

C Declare variables

      implicit none
      include 'comblock'
      include 'tubecom'
      real sphi,cphi,stheta,ctheta,spsi,cpsi,xt,yt
      integer tubct,i

C Begin subroutine
C Initialize headtub
      Do i=1,ntt
         headtub(i)=0
      End do

C Setup Eulerian angle transformation matrix
      cphi=COS(phi)
      sphi=SIN(phi)
      ctheta=COS(theta)
      stheta=SIN(theta)
      cpsi=COS(psi)
      spsi=SIN(psi)
      lambda(1,1)=cpsi*cphi-ctheta*sphi*spsi
      lambda(2,1)=(-1.0)*spsi*cphi-ctheta*sphi*cpsi
      lambda(3,1)=stheta*sphi
      lambda(1,2)=cpsi*sphi+ctheta*cphi*spsi
      lambda(2,2)=(-1.0)*spsi*sphi+ctheta*cphi*cpsi
      lambda(3,2)=(-1.0)*stheta*cphi
      lambda(1,3)=spsi*stheta
      lambda(2,3)=cpsi*stheta
      lambda(3,3)=ctheta


C The real data begins here

      Do i=1,cntp

C Find rotated particle position

	 xt=x(i)-x1
	 yt=y(i)-y1
         xr(i)=lambda(1,1)*xt+lambda(1,2)*yt+lambda(1,3)*z(i)
         yr(i)=lambda(2,1)*xt+lambda(2,2)*yt+lambda(2,3)*z(i)
         zr(i)=lambda(3,1)*xt+lambda(3,2)*yt+lambda(3,3)*z(i)
         tubct=INT((xr(i)+shift)/tubwid)+(INT((yr(i)+shift)/tubwid)-1)
     &         *tubmax

C don't write to tube if tube overflow occurs!

         if ((headtub(tubct)+1).gt.numptub) then
            goto 75
         else
            headtub(tubct)=headtub(tubct)+1
            tublist(headtub(tubct),tubct)=i
         end if
 75      continue
      End do

      Return
      End







