C Programmer: Chris Burke
C Date: June 20, 1997
C Purpose: Creates table of temperatures v UBVRI magnitudes of a black body.

      Subroutine bbody

C Declare variables

      include 'comblock'
      include 'tubecom'
      integer i,j
      integer numsteps,fnux,fnb,fnv,fnr,fne,fnbx
      double precision lamsta, lamend,tsta,tend
      parameter (numsteps=400,fnux=75,fnb=63,fnv=63,fnr=51,fne=63)
      parameter (fnbx=63)
      parameter(lamsta=3000.0d0,lamend=9200.0d0,tsta=5.0d2,tend=1.0d5)
      double precision wavlen(numsteps),care,wav,uxval,bval,vval,cnt
      double precision rval,eval,ry(fnr),ey(fne),bxval,bxy(fnbx)
      double precision wavspux(fnux),uxy(fnux),wavspb(fnb),wavspv(fnv)
      double precision by(fnb),vyy(fnv),wavspr(fnr),wavspe(fne)
      double precision wavspbx(fnbx),bxy2(fnbx)
      double precision uxy2(fnux),by2(fnb),vy2(fnv),tval
      double precision ey2(fne),ry2(fnr),rtmp(numsteps),etmp(numsteps)
      double precision lamtmp,uxtmp(numsteps),bbtmp,bb
      double precision bxtmp(numsteps),btmp(numsteps),vtmp(numsteps)
      double precision uxx(numsteps),bx(numsteps),vxx(numsteps),exmean
      double precision rx(numsteps),ex(numsteps),rsum,esum,rxmean
      double precision uxsum,bsum,vsum,dl,uxxmean,bxmean,vxmean
      double precision bxx(numsteps),bxxmean,bxsum

C Begin Subroutine
C Find the wavelength values for wavlen(i)
      care=(lamend-lamsta)/DBLE(numsteps)
      cnt=0.0d0
      Do i=1,numsteps
         wavlen(i)=lamsta+cnt*care
         cnt=cnt+1.0d0
      End do
C Find the temperature values for temps(i)
      care=(DLOG10(tend/tsta))/DBLE(numtemps)
      cnt=0.0d0
      Do i=1,numtemps
         temps(i)=DLOG10(tsta)+cnt*care
         cnt=cnt+1.0d0
      End do

C Do spline interpolation to get curves for filter data
C First read in data from uband.bes
      Open(Unit=2,file='/home/wood/pgms/disk2.1/uxband.bes',status='old')
      Do i=1,fnux
         Read(2,*) wav,uxval
         wavspux(i)=wav*10.0d0
         uxy(i)=uxval
      End do
      Close(Unit=2)
C Read in data from bband.bes
      Open(Unit=2,File='/home/wood/pgms/disk2.1/bband.bes',Status='old')
      Do i=1,fnb
         Read(2,*) wav,bval
         wavspb(i)=wav*10.0d0
         by(i)=bval
      End do
      Close(Unit=2)
C Read in data from bxband.bes
      Open(Unit=2,File='/home/wood/pgms/disk2.1/bxband.bes',Status='old')
      Do i=1,fnbx
         Read(2,*) wav,bxval
         wavspbx(i)=wav*10.0d0
         bxy(i)=bxval
      End do
      Close(Unit=2)
C Read in data from vband.bes
      Open(Unit=2,File='/home/wood/pgms/disk2.1/vband.bes',Status='old')
      Do i=1,fnv
         Read(2,*) wav,vval
         wavspv(i)=wav*10.0d0
         vyy(i)=vval
      End do
      Close(Unit=2)
C Read in data from rband.bes
      Open(Unit=2,File='/home/wood/pgms/disk2.1/rband.bes',Status='old')
      Do i=1,fnr
         Read(2,*) wav,rval
         wavspr(i)=wav*10.0d0
         ry(i)=rval
      End do
      Close(Unit=2)
C Read in data from iband.bes
      Open(Unit=2,File='/home/wood/pgms/disk2.1/iband.bes',Status='old')
      Do i=1,fne
         Read(2,*) wav,eval
         wavspe(i)=wav*10.0d0
         ey(i)=eval
      End do
      Close(Unit=2)
C Call spline to get second derivs
      call spline(wavspux,uxy,fnux,0.0d0,0.0d0,uxy2)
      call spline(wavspbx,bxy,fnbx,0.0d0,0.0d0,bxy2)
      call spline(wavspb,by,fnb,0.0d0,0.0d0,by2)
      call spline(wavspv,vyy,fnv,0.0d0,0.0d0,vy2)
      call spline(wavspr,ry,fnr,0.0d0,0.0d0,ry2)
      call spline(wavspe,ey,fne,0.0d0,0.0d0,ey2)
      Do i=1,numsteps
         lamtmp=wavlen(i)
C these values correspond to the filter's end of response.
         if (lamtmp.lt.3000.AND.lamtmp.gt.4200) Then
            uxtmp(i)=0.0d0
         else
            call splint(wavspux,uxy,uxy2,fnux,lamtmp,uxtmp(i))
         end if
         if (lamtmp.lt.3600.AND.lamtmp.gt.5600) Then
            bxtmp(i)=0.0d0
         else
            call splint(wavspbx,bxy,bxy2,fnbx,lamtmp,bxtmp(i))
         end if
         if (lamtmp.lt.3600.AND.lamtmp.gt.5600) Then
            btmp(i)=0.0d0
         else
            call splint(wavspb,by,by2,fnb,lamtmp,btmp(i))
         end if
         if (lamtmp.lt.4700.AND.lamtmp.gt.7000) Then
            vtmp(i)=0.0d0
         else
            call splint(wavspv,vyy,vy2,fnv,lamtmp,vtmp(i))
         end if
         if (lamtmp.lt.5500.AND.lamtmp.gt.9000) Then
            rtmp(i)=0.0d0
         else
            call splint(wavspr,ry,ry2,fnr,lamtmp,rtmp(i))
         end if
         if (lamtmp.lt.7000.AND.lamtmp.gt.9200) Then
            etmp(i)=0.0d0
         else
            call splint(wavspe,ey,ey2,fne,lamtmp,etmp(i))
         end if
C Check passbands
c         print*,lamtmp,uxtmp(i),bxtmp(i),btmp(i),vtmp(i),
c     &          rtmp(i),etmp(i)
c10      format(1x,f7.1,1x,6(f10.7,1x))
      End do
C Use this to loop through temperatures non-interactively
      Do j=1,numtemps
      tval=10.0**temps(j)
      uxsum=0.0d0
      bxsum=0.0d0
      bsum=0.0d0
      vsum=0.0d0
      rsum=0.0d0
      esum=0.0d0
      Do i=1,numsteps
         lamtmp=wavlen(i)
         bbtmp=BB(tval,lamtmp)

	 uxx(i) = uxtmp(i) * bbtmp
         bxx(i) = bxtmp(i) * bbtmp
	 bx(i) = btmp(i) * bbtmp
	 vxx(i) = vtmp(i) * bbtmp
         rx(i) = rtmp(i) * bbtmp
         ex(i) = etmp(i) * bbtmp
C Begin to integrate
         if (i.ne.1) then
            dl = DABS(lamtmp - wavlen(i-1))
            uxxmean = (uxx(i)+uxx(i-1))/2.
            bxxmean = (bxx(i)+bxx(i-1))/2.
            bxmean = (bx(i)+bx(i-1))/2.
            vxmean = (vxx(i)+vxx(i-1))/2.
            rxmean = (rx(i)+rx(i-1))/2.
            exmean = (ex(i)+ex(i-1))/2.

	    uxsum = uxsum + dl*uxxmean
            bxsum = bxsum + dl*bxxmean
	    bsum = bsum + dl*bxmean
	    vsum = vsum + dl*vxmean
	    rsum = rsum + dl*rxmean
	    esum = esum + dl*exmean

         end if
      End do
      uxsums(j)=uxsum
      bxsums(j)=bxsum
      bsums(j)=bsum
      vsums(j)=vsum
      rsums(j)=rsum
      esums(j)=esum
      End do

C Do spline so interpolated values can be found later
      call spline(temps,uxsums,numtemps,1.0d30,1.0d30,uxsums2)
      call spline(temps,bxsums,numtemps,1.0d30,1.0d30,bxsums2)
      call spline(temps,bsums,numtemps,1.0d30,1.0d30,bsums2)
      call spline(temps,vsums,numtemps,1.0d30,1.0d30,vsums2)
      call spline(temps,rsums,numtemps,1.0d30,1.0d30,rsums2)
      call spline(temps,esums,numtemps,1.0d30,1.0d30,esums2)
      

 999  continue
      Return
      End

C Functions and subroutines begin here------------------------------------
      SUBROUTINE SPLINE(X,Y,N,YP1,YPN,Y2)
	implicit double precision(a-h,o-z)
      PARAMETER (NMAX=501)
      DIMENSION X(N),Y(N),Y2(N),U(NMAX)
      IF (YP1.GT..99E30) THEN
        Y2(1)=0.
        U(1)=0.
      ELSE
        Y2(1)=-0.5
        U(1)=(3./(X(2)-X(1)))*((Y(2)-Y(1))/(X(2)-X(1))-YP1)
      ENDIF
      DO 11 I=2,N-1
        SIG=(X(I)-X(I-1))/(X(I+1)-X(I-1))
        P=SIG*Y2(I-1)+2.
        Y2(I)=(SIG-1.)/P
        U(I)=(6.*((Y(I+1)-Y(I))/(X(I+1)-X(I))-(Y(I)-Y(I-1))
     *      /(X(I)-X(I-1)))/(X(I+1)-X(I-1))-SIG*U(I-1))/P
11    CONTINUE
      IF (YPN.GT..99E30) THEN
        QN=0.
        UN=0.
      ELSE
        QN=0.5
        UN=(3./(X(N)-X(N-1)))*(YPN-(Y(N)-Y(N-1))/(X(N)-X(N-1)))
      ENDIF
      Y2(N)=(UN-QN*U(N-1))/(QN*Y2(N-1)+1.)
      DO 12 K=N-1,1,-1
        Y2(K)=Y2(K)*Y2(K+1)+U(K)
12    CONTINUE
      RETURN
      END
c---------------------------------------------------------------------
      subroutine splint(xa,ya,y2a,n,x,y)
	integer n
	real*8 x,y,xa(n),ya(n),y2a(n),a,b,h
	integer k,khi,klo
	klo=1
	khi=n
1	if(khi-klo.gt.1) then
	 k=(khi+klo)/2
	 if(xa(k).gt.x) then
	  khi=k
	 else
	  klo=k
	 end if
	 go to 1
	end if
      	if(khi.eq.klo) then
	 y=ya(klo)
	else if(x.eq.xa(klo))then
	 y=ya(klo)
	else if(x.eq.xa(khi))then
	 y=ya(khi)
	else
	 h=xa(khi)-xa(klo)
         a=(xa(khi)-x)/h
         b=(x-xa(klo))/h
         y=a*ya(klo)+b*ya(khi)+
     *      ((a**3-a)*y2a(klo)+(b**3-b)*y2a(khi))*(h**2)/6.
	end if
	return
	end
C---------------------------------------------------------------
	Function bb(t,al)

c        double precision bb,t,al,c1,c2,e
C BB function from Allen's Astrophysical Quantities p.104
C Overall units are erg/s/cm^2/cm
C c1 is erg*cm^2/s
C c2 is cm*K
C al needs to be put into cm
c        al=al*1.0d-8
c        c1=3.74185d-5
c        c2=1.43883
c        e=dexp(c2/(al*t))
c        bb=(c1/al**5)/(e-1.0d0)
	implicit double precision(a-h,o-z)

	cst = 1.191062e35
	e  = dexp(143882054.5/al/t)
	bb = cst / (al**5) / (e-1.0)
	return
	end


