c    
c    DiskSim: A Cataclysmic Variable Accretion Disk Simulator
c    
c    Authors:  James C. Simpson (deceased)
c              Matt A. Wood, Texas A&M University-Commerce
c    
c    About: 
c    Jim Simpson wrote DiskSim as part of his Ph.D. thesis project
c    (Simpson 1995).  Jim died unexpectedly on December 14, 2013, but he
c    would be very happy to know that his code lives on and is useful.  Jim
c    named the code JDISK, and I've kept that as the name of the main
c    program file (jdisk.f), however I decided to call it DiskSim for this
c    release.  In my mind, the "Sim" stands for simulation, but it also
c    stands for Simpson.  Jim was a good man and brilliant.  He left
c    academia to work at NASA at the Kennedy Space Center, where he made a
c    positive difference to those around him.  
c    
c    I'll have more in this README file eventually.  The code is written in
c    standard Fortran (77!), so you should be able to be able to unpack the
c    tar file, type 'make', and once it is compiled, 'disksim'.  The code
c    prompts the user for inputs.  You may want to check back for updates -
c    I'll get around to fixing some of the odd inputs - but you should be
c    able to get started and run some disk models.  
c    
c    The code as tarred has a limit of 110000 particles - you can change
c    this in 'comblock' if you like.  
c    
c    For an explanation of the code, see Simpson (1995, ApJ 448, 822).
c    
c    If you use this code in your research, please cite:
c    
c    * Simpson, J.C. and Wood, M.A. (1998, ApJ, 506, 360)
c    * Wood, M.A., Thomas, D.M., and Simpson, J.C. (2009, MNRAS, 398, 2110)
c    
c    I'd be interested to hear from you if you have comments or suggestions.  
c    
c    Note 1: This code is a research code, and has some unique features and
c    random naming conventions.  You are welcome to use it for your
c    research or for fun, but I offer no guarantee that the results are
c    correct or physically-relevant.  You agree that your are using this code
c    at your own risk.
c    
c    Note 2: This code is now Open Source.  You can download it, run it,
c    and modify it for your own purposes.  If you find mistakes/bugs,
c    please contact me.  If you use it in a research project, I'd love to
c    have you send me a PDF of the paper, or a link.
c    
c    Best regards,
c    
c    Matt A. Wood
c    Department of Physics & Astronomy
c    Texas A&M University-Commerce
c    Commerce, TX 75401
c    Matt.Wood@tamuc.edu
c
c  (END OF README - 2016 Dec 12)
c
	program disksim

c	7/15/97
	
	include 'comblock'

	debug = .false.

c	call setup where everything gets set up and read in

	call setup

c	call step where all the number crunching gets done

	call step

	end


