
	subroutine equipot

c	determines the locus of points defining the equipotential near m2

	include'comblock'

	integer i,j,flag
	real delxx,delyy,xx,delx1sq,delx2sq,yy
	real yyp,equifunc,delyinit,temp

c	establish limits on x, i.e. from rl to rlo. The 25 increments
c	is arbitrary, can be small since only used to make a pretty
c	picture on the plots

	temp=mu2-rl

	delxx=(rlo-rl)/25.
	delyinit=0.1*temp

c	assign initial values

	xl(1)=rl
	yl(1)=0.0	

	do i=1,24
	delyy=delyinit
	  xx=rl+real(i)*delxx
	  delx1sq=(xx+mu1)*(xx+mu1)
	  delx2sq=(xx-mu2)*(xx-mu2)
	  yy=sqrt(temp*temp-delx2sq)

c	solve potential equation iteratively using sqrt(lm2sq-delx2sq) 
c	as the initial guess for y, decreasing y until an
c	adequately close zero is obtained. yyp=previous value for y,dely is
c	arbitrarily set at 0.1*lm2, j is counter for number of times
c	del is reduced by a factor of 10. flag is indicator if done

	yyp=yy
	j=1
	flag=0

c	make initial check that equ IS neg

	if (equifunc(yy,delx1sq,delx2sq,mu1,mu2,phirl).ge.0.0) then
	  print*,'bad news'
	  flag=1
	end if
	
	do while (flag.eq.0)

c	first see if equ <0, if so decrease y by dely

	if(equifunc(yy,delx1sq,delx2sq,mu1,mu2,phirl).lt.0.0) then
		yyp=yy
		yy=yy-delyy

c	if equ>0, then go back to previous value of yy and decrease
c	del by factor of 10 and start again. The 5 means that the result
c	is accurate out to about the 5 th decimal place since
c	del(initial) is about .1

	else if (equifunc(yy,delx1sq,delx2sq,mu1,
     1	   mu2,phirl).gt.0.0.and.j.le.5) then
		delyy=0.1*delyy
		j=j+1
		yy=yyp-delyy

c	all done

	else
		flag=1
		xl(i+1)=xx
		yl(i+1)=yy
	end if
	end do
	end do

	xl(26)=rlo
	yl(26)=0.0

	j=25
	do i=27,51
	  xl(i)=xl(j)
	  yl(i)=-yl(j)
	  j=j-1
	end do

	return
	end
	

	real function equifunc(y,dx1sq,dx2sq,mu1,mu2,phirl)

	real y,dx1sq,dx2sq,mu1,mu2,phirl,term1,term2,ysq
	real y1sq,y2sq,term3,term4

	ysq=y*y
	y1sq=ysq+dx1sq
	y2sq=ysq+dx2sq
	term1=mu2/sqrt(y1sq)
	term2=mu1/sqrt(y2sq)
	term3=mu2*y1sq
	term4=mu1*y2sq
	equifunc=phirl+term1+term2+.5*(term3+term4)
	return
	end
