	subroutine fluid1

c	gets all the fluid stuff. Only bin 1 gets acc/vels updated. 

	include'comblock'

	integer i,j,add,tadd
	real fac,tvrdot,dudt,sum

c	first get the densities and press/rho**2 for bin 1

	do i=1,headbin(1)
	    add=bin(i,1)
	    sum=1.0
	    do j=2,headlist(add)
	        sum=sum+kernel(kerindex(j,add))
	    end do
	    rho(add)=sum
	    pressrho(add)=gamma1*u(add)/sum
	end do

c	get the fluid accelerations, add these to gravity accelerations
c	and update velocities

	do i=1,headbin(1)
	    add=bin(i,1)
	    axgas(add)=0.0
	    aygas(add)=0.0
	    azgas(add)=0.0 
	    do j=2,headlist(add)
	       if(partbin(list(j,add)).eq.1) then
	           tadd=list(j,add)
                   tvrdot=(x(add)-x(tadd))*(vxend(add)-vxend(tadd))+
     1                    (y(add)-y(tadd))*(vyend(add)-vyend(tadd))+
     1                    (z(add)-z(tadd))*(vzend(add)-vzend(tadd))
                   if(tvrdot.lt.0.0) then
                       tvrdot=tvrdot*rsqeta(kerindex(j,add))/(cs(add)+cs(tadd))
	               fac=(1.0+tvrdot*(alpha+beta*tvrdot))*
     1	                   grdkernel(kerindex(j,add))*(pressrho(add)+pressrho(tadd))
                   else
                       fac=(pressrho(add)+pressrho(tadd))*grdkernel(kerindex(j,add))
	           end if  ! tvrdot<0
	           axgas(add)=axgas(add)+fac*(x(tadd)-x(add))
	           aygas(add)=aygas(add)+fac*(y(tadd)-y(add))
	           azgas(add)=azgas(add)+fac*(z(tadd)-z(add))
	       end if  !partbin(list(j,add))=1	 
	    end do  ! j

	    ax(add)=axgas(add)+axgr(add)
	    ay(add)=aygas(add)+aygr(add)
	    az(add)=azgas(add)+azgr(add)

	    vxend(add)=vx(add)+deltmin12*ax(add)
	    vyend(add)=vy(add)+deltmin12*ay(add)
	    vzend(add)=vz(add)+deltmin12*az(add)

	    vx(add)=vx(add)+deltmin*ax(add)
	    vy(add)=vy(add)+deltmin*ay(add)
	    vz(add)=vz(add)+deltmin*az(add)

	end do  ! i

c       now get estimate for internal energy at end of current timestep

	sum=0.0

        do i=1,headbin(1)
            add=bin(i,1)
            dudt=-(axgas(add)*vx(add)+aygas(add)*vy(add)+
     1	         azgas(add)*vz(add))

            if((u(add)+dudt*deltmin).gt.umin) then

	        ec11=ec11+1
                u(add)=(u(add)+dudt*deltmin)
                cs(add)=sqrt(cscon*u(add))
	        sum=sum+dudt

            else 

	        dudt=0.0
	        do j=2,headlist(add)
	            if(partbin(list(j,add)).eq.1) then
	                tadd=list(j,add)
	                tvrdot=(x(add)-x(tadd))*(vxend(add)-vxend(tadd))+
     1                         (y(add)-y(tadd))*(vyend(add)-vyend(tadd))+
     1                         (z(add)-z(tadd))*(vzend(add)-vzend(tadd))
	                if(tvrdot.lt.0.0) then
                            fac=tvrdot*rsqeta(kerindex(j,add))/(cs(add)+cs(tadd))
                            dudt=dudt+(1.0+fac*(alpha+beta*fac))*tvrdot*
     1                           grdkernel(kerindex(j,add))
                        else
                            dudt=dudt+tvrdot*grdkernel(kerindex(j,add))
	                end if  ! tvrdot<0
	            end if
	        end do  ! j
	       dudt=pressrho(add)*dudt

               if((u(add)+dudt*deltmin).gt.umin) then

	           ec12=ec12+1
                   u(add)=(u(add)+dudt*deltmin)
                   cs(add)=sqrt(cscon*u(add))
	           sum=sum+dudt

               else 

	           dudt=(ufudge-u(add))/deltmin
	           u(add)=ufudge
	           cs(add)=csfudge
	           badness1=badness1+1
	           sum=sum+dudt*deltmin

                end if
	    end if
        end do 

	enersum=enersum+sum*deltmin

	return
	end
