	subroutine lagrange

c	determines the location of the inner Lagrange point L1

	include'comblock'

	integer i,flag
	real uu,u2,u3,u4,c0,c1,c2,c3,c4
	real xt,xx,xxp,del,equ

c	define the fifth degree polynomial which yields L1

	equ(xt)=(xt**5)+(c4*(xt**4))+(c3*(xt**3))+(c2*(xt**2))
     1	+(c1*xt)+c0

c	get the necessary powers of mu and constants 

	uu=mu2
	u2=uu*uu
	u3=u2*uu
	u4=u3*uu

	c0=-(2.0*u3)+(3.0*u2)-(3.0*uu)+1.0
	c1=u4-(2.0*u3)+(5.0*u2)-(4.0*uu)+2.0
	c2=-(4.0*u3)+(6.0*u2)-(4.0*uu)+1.0
	c3=(6.0*u2)-(6.0*uu)+1.0
	c4=2.0-(4.0*uu)

c	solve this equation iteratively using mu2 as the initial guess.
c	This just starts x at mu2 and decreases x until an adequately
c	close zero is obtained.

c	initial guess for x is mu, xxp=previous value for x,del is
c	arbitrarily set at 0.1mu  i is counter for number of times
c	del is reduced by a factor of 10. flag is indicator if done

	xx=uu
	xxp=xx
	del=0.1*uu
	i=1
	flag=0
	
	do while (flag.eq.0)

c	first see if equ >0, if so decrease x by del x

	if(equ(xx).gt.0.0) then
		xxp=xx
		xx=xx-del

c	if equ<0, then go back to previous value of xx and decrease
c	del by factor of 10 and start again. The 5 means that the result
c	L1 is accurate out to about the 5 th decimal place since
c	del(initial) is about .1

	else if (equ(xx).lt.0.0.and.i.le.5) then
		del=0.1*del
		i=i+1
		xx=xxp-del

c	all done

	else
		flag=1
		rl=xx
c	        lm2=mu2-rl
	end if

	end do

	print*,' L1=',rl,'  lm1=',lm1,' mu2-rl=',mu2-rl
c	lm2sq=lm2**2

	return
	end
	
