	subroutine move1(pcount)

c       advances positions of particles in bin 1 by deltmin
c	checks if still in the system,injects new particle prn
c	finds gravitational acceleratiom due to m1 and m2

	include'comblock'

	integer i,j,add,pcount,pass
	real mu1rad2,mu2rad1,dcinj,dsinj,r1sq,r2sq

c	get locations of m1,m2 and dcinj,dsinj(for use in inject)

	x1=arx11(pcount,count)
	y1=ary11(pcount,count)
	x2=arx21(pcount,count)
	y2=ary21(pcount,count)
	dcinj=ardc1(pcount,count)
	dsinj=ards1(pcount,count)

c	move bin 1 first. Get gravitational accelerations.

	do i=1,headbin(1)
	 add=bin(i,1)
	 x(add)=x(add)+vx(add)*deltmin
	 y(add)=y(add)+vy(add)*deltmin
	 z(add)=z(add)+vz(add)*deltmin
	 r1sq=((x(add)-x1)**2)+((y(add)-y1)**2)+(z(add)**2)
	 r2sq=((x(add)-x2)**2)+((y(add)-y2)**2)+(z(add)**2)

c	check for loss from system or capture by m1 or m2

	 if (((x(add)-x1)**2)+((y(add)-y1)**2).ge.largecheck.or.
     1	  (z(add)**2).ge.largezcheck) then 

c	particle out of the system bounds
  
	  numlostsys=numlostsys+1
	  call inj1(add,dcinj,dsinj,1)

	 else if (r1sq.le.lm1sq) then
	
c	particle captured by m1
  
	  numlostm1=numlostm1+1
	  call inj1(add,dcinj,dsinj,1)

	 else if (r2sq.le.lm2sq) then

c	particle captured by m2

	  numlostm2=numlostm2+1
	  call inj1(add,dcinj,dsinj,1)

	 else
 
c	if a particle makes it to here, it stays in the system.
c	So, find gravitational accelerations due to m1 and m2.
c	Capture by m1 or m2 only checked in move2.

  
          mu2rad1=mu2/(sqrt(r1sq)**3)
          mu1rad2=mu1/(sqrt(r2sq)**3)

          axgr(add)=-((x(add)-x1)*mu2rad1+(x(add)-x2)*mu1rad2)
          aygr(add)=-((y(add)-y1)*mu2rad1+(y(add)-y2)*mu1rad2)
          azgr(add)=-z(add)*(mu2rad1+mu1rad2)

          vxend(add)=vx(add)+deltmin12*(axgr(add)+axgas(add))
          vyend(add)=vy(add)+deltmin12*(aygr(add)+aygas(add))
          vzend(add)=vz(add)+deltmin12*(azgr(add)+azgas(add))  

	 end if

	end do ! i=1,headbin(1)

c	now move particles in all other time bins

	do i=2,nmax
	pass=0
	 do j=1,headbin(i)
          add=bin(j,i)
	  x(add)=x(add)+vx(add)*deltmin
	  y(add)=y(add)+vy(add)*deltmin
	  z(add)=z(add)+vz(add)*deltmin

c	check for loss from system

	  if ((x(add)-x1)**2+(y(add)-y1)**2.ge.largecheck.or.
     1	   z(add)**2.ge.largezcheck) then  
	   numlostsys=numlostsys+1
	   call inj1(add,dcinj,dsinj,i)
	
	  else 

c	particle stays in system,  put on tlist 

	   pass=pass+1
	   tlist(pass)=add 
	
	  end if
	 end do ! j=1,headbin(i)

c	write tlist back onto bin

	 do j=1,pass
	  bin(j,i)=tlist(j)
	 end do

	 headbin(i)=pass
	  
	end do ! i=2,nmax

	return
	end

	subroutine inj1(add,dcinj,dsinj,binflag)

	include'comblock'

	integer add,binflag
	real ranmar,dcinj,dsinj,xinj,yinj,xx,yy,zz,mu2rad1,mu1rad2

c	determine position inside box 

	xinj=xcone*ranmar(add)
	yinj=(2.*ranmar(add)-1.)*yzcone
	zz=(2.*ranmar(add)-1.)*yzcone

c 	and in system coordinates

	xx=(rl-xinj)*dcinj-yinj*dsinj
	yy=(rl-xinj)*dsinj+yinj*dcinj

	x(add)=xx
	y(add)=yy
	z(add)=zz + L1_z
!	z(add)=zz + L1_z*sin(pi2*real(count)/real(countmax))
!	write(*,*) 'count, countmax, z(add) = ',count,countmax,z(add)

c	now get the end velocities wrt the system

        vxend(add)=-vth*dcinj-yy
        vyend(add)=-vth*dsinj+xx
        vzend(add)=0.0

c	now get the accelerations due to m1 and m2 and get vreg 

	mu2rad1=mu2/((sqrt((x1-xx)**2+(y1-yy)**2)+zz**2)**3)
	mu1rad2=mu1/((sqrt((x2-xx)**2+(y2-yy)**2)+zz**2)**3)

	axgr(add)=(x1-xx)*mu2rad1+(x2-xx)*mu1rad2
	aygr(add)=(y1-yy)*mu2rad1+(y2-yy)*mu1rad2
	azgr(add)=-zz*(mu1rad2+mu2rad1)

	ax(add)=axgr(add)
	ay(add)=aygr(add)
	az(add)=azgr(add)

        vx(add)=vxend(add)-deltmin12*axgr(add)
        vy(add)=vyend(add)-deltmin12*aygr(add)
        vz(add)=vzend(add)-deltmin12*azgr(add)

	axgas(add)=0.0
	aygas(add)=0.0
	azgas(add)=0.0

	u(add)=uinj
	cs(add)=csinj

	if(binflag.gt.1) then
	 headbin(1)=headbin(1)+1
	 bin(headbin(1),1)=add
	 partbin(add)=1
	end if

	return
	end
