	subroutine sort

c	obtain lists of nearest neighbors for all particles in bins
c	less than or equal to highbin (which is less than bin max)

	include'comblock'

	integer i,j,k,m,tadd,boxct,addct,boxtest,index,dum
	integer add,zlevelt,zlevel2start,headboxtest,zlevel2stop
	real xshift,yshift

c	first get xshift and yshift

	xshift=h2+large-x1
	yshift=h2+large-y1

c	initialize headzlevel(i)=0

	do i=1,zlevelmax
	 headzlevel(i)=0
	end do

c	put particles into zlevels. Initialize headlist(i)=1 (itself!)

	do i=1,cntp
         zlevelt=int((z(i)+zshift)*h2inv)
         headzlevel(zlevelt)=headzlevel(zlevelt)+1
         zlevel(headzlevel(zlevelt),zlevelt)=i
         headlist(i)=1  ! puts particle first on its own list
	end do

c       initialize all kinds of stuff

        tcount=0
        zlevel2start=0
        zlevel2stop=0

        do i=1,maxboxnum
         headbox(i)=0
        end do

c	sort zlevels from bottom to top

	do i=2,maxzlevelsort

	 if(headzlevel(i).gt.0) then

	 if(headzlevel(i-1).gt.0) then

c	copy boxes from what was zlevel(i+1) to current zlevel(i). 

	  tcount=0
	  do j=zlevel2start,zlevel2stop
	   tcount=tcount+1
	   dum=tbox(j)
	   boxct=dum-maxboxnum12
	   tbox(tcount)=boxct
	   do k=1,headbox(dum)
	    box(k,boxct)=box(k,dum)
	   end do
	   headbox(boxct)=headbox(dum)
	   headbox(dum)=0 ! reinitialize headbox to 0
	  end do
	 
	 else

c	Put particles in zlevel(i) into xy boxes.

          do j=1,headzlevel(i)
	   add=zlevel(j,i)
           boxct=int((x(add)+xshift)*h2inv)+
     1      (int((y(add)+yshift)*h2inv)-1)*boxmax
            headbox(boxct)=headbox(boxct)+1
            box(headbox(boxct),boxct)=add
	  end do

c	make list of occupied boxes in ascending order

	  tcount=0
	  do j=1,maxboxnum12
	   if (headbox(j).gt.0) then
	    tcount=tcount+1
	    tbox(tcount)=j
	   end if
	  end do

	 end if ! if(headzlevel(i-1).gt.0)

c	now put particles on the next level up into boxes

	 if (headzlevel(i+1).gt.0) then

c	Put particles in zlevel(i+1) into xy boxes. 

	  k=i+1
          do j=1,headzlevel(k)
	   add=zlevel(j,k)
           boxct=(int((x(add)+xshift)*h2inv)+
     1      (int((y(add)+yshift)*h2inv)-1)*boxmax)+maxboxnum12
           headbox(boxct)=headbox(boxct)+1
           box(headbox(boxct),boxct)=add
	  end do

c	make list of occupied boxes in ascending order

	  zlevel2start=tcount+1
	  dum=tcount
	  do j=maxboxnum12+1,maxboxnum
	   if (headbox(j).gt.0) then
	    dum=dum+1
	    tbox(dum)=j
	   end if
	  end do
	  zlevel2stop=dum

	 end if ! if (headzlevel(i+1).gt.0) 

c	search all occupied boxes in zlevel(i) against boxes in
c	zlevel(i) and zlevel(i+1)

	 do j=1,tcount

	  boxtest=tbox(j) !boxtest is box being searched
	  headboxtest=headbox(boxtest)

c	first make a temporary one-dimensional array list of
c	particles in the boxes on boxlist for boxtest which have
c	a larger identification number than boxtest.

	  addct=0
	  do k=1,headboxlist(boxtest)
	   do m=1,headbox(boxlist(k,boxtest))
	    addct=addct+1
	    tlist(addct)=box(m,boxlist(k,boxtest))
	   end do
	  end do

	 do k=1,headboxtest
	  add=box(k,boxtest)

c 	test for partbin(add)<= highbin

	  if(partbin(add).le.highbin) then

c	Search add against other particles in boxtest that have not 
c	already been searched on prior passes thru this loop.
c	Use pair-wise symmetry. 

	  do m=k+1,headboxtest
	   tadd=box(m,boxtest)
	   if (((x(add)-x(tadd))**2+(y(add)-y(tadd))**2+
     1	    (z(add)-z(tadd))**2).lt.h2sq) then

	    index=nint(sqrt(((x(add)-x(tadd))**2+(y(add)-y(tadd))**2+
     1	     (z(add)-z(tadd))**2))*convert)+1

c	first for add's list

	    headlist(add)=headlist(add)+1
	    list(headlist(add),add)=tadd
	    kerindex(headlist(add),add)=index
  
c	now for tadd's list if necessary

	    if(partbin(tadd).le.highbin) then
	     headlist(tadd)=headlist(tadd)+1
	     list(headlist(tadd),tadd)=add
	     kerindex(headlist(tadd),tadd)=index
	    end if !partbin(tadd)<=highbin
  
	   end if  ! rrsq<h2sq
	  end do !m=k+1,headboxtest

c	now search all particles in boxtest against the list
c	tlist(m). Use pair-wise symmetry again. 

	   do m=1,addct
	   tadd=tlist(m)
	   if((x(add)-x(tadd))**2.lt.h2sq) then
	   if (((x(add)-x(tadd))**2+(y(add)-y(tadd))**2+
     1	    (z(add)-z(tadd))**2).lt.h2sq) then

	    index=nint(sqrt(((x(add)-x(tadd))**2+(y(add)-y(tadd))**2+
     1	     (z(add)-z(tadd))**2))*convert)+1

c	first for add's list

	    headlist(add)=headlist(add)+1
	    list(headlist(add),add)=tadd
	    kerindex(headlist(add),add)=index

c	now for tadd's list if necessary

	    if(partbin(tadd).le.highbin) then
	     headlist(tadd)=headlist(tadd)+1
	     list(headlist(tadd),tadd)=add
	     kerindex(headlist(tadd),tadd)=index
	    end if ! partbin(tadd)<=highbin
  
	   end if  ! abs(x(add)-x(tadd)).lt.h2
	   end if  ! rrsq.lt.h2sq 
	   end do  ! m=1,addct

	else  ! partbin(add)>highbin

c	like above but test on partbin(tadd)<=highbin and don't
c	need to worry about add 

	  do m=k+1,headboxtest
	   tadd=box(m,boxtest)
	   if(partbin(tadd).le.highbin) then
	   if (((x(add)-x(tadd))**2+(y(add)-y(tadd))**2+
     1	    (z(add)-z(tadd))**2).lt.h2sq) then

	    headlist(tadd)=headlist(tadd)+1
	    list(headlist(tadd),tadd)=add
	    kerindex(headlist(tadd),tadd)=nint(sqrt(((x(add)-
     1	     x(tadd))**2+(y(add)-y(tadd))**2+
     1	     (z(add)-z(tadd))**2))*convert)+1

	   end if  ! rrsq<h2sq
	   end if  ! partbin(tadd)<= highbin
	  end do   ! m=k+1,headboxtest

	  do m=1,addct
	   tadd=tlist(m)
	   if(partbin(tadd).le.highbin) then
	   if((x(add)-x(tadd))**2.lt.h2sq) then
	   if (((x(add)-x(tadd))**2+(y(add)-y(tadd))**2+
     1	    (z(add)-z(tadd))**2).lt.h2sq) then

	    headlist(tadd)=headlist(tadd)+1
	    list(headlist(tadd),tadd)=add
	    kerindex(headlist(tadd),tadd)=nint(sqrt(((x(add)-
     1	     x(tadd))**2+(y(add)-y(tadd))**2+
     1	     (z(add)-z(tadd))**2))*convert)+1
  
	   end if ! abs(x(add)-x(tadd)).lt.h2
	   end if ! rrsq.lt.h2sq 
	   end if ! partbin(tadd)<= highbin
	  end do  ! m=1,addct
	  end if  ! partbin(add)<=highbin
	 end do   ! k=1,headboxtest

c	since boxtest is all done, reset its head to 0

	 headbox(boxtest)=0

	end do ! j=1,tcount
	end if ! headzlevel(i)>0
	end do ! i=1,maxzlevel

	return
	end
