C     Programmer:Chris Burke
C     Date: July 15, 1997
C     Purpose: Finds surface based on the average z values for all
c     particles which lie above the smoothed avgz(i)

      Subroutine surface

C Declare variables
      implicit none
      include 'comblock'
      include 'tubecom'
      real sumz
      integer i,j,m,ii,jj,rowct,tubeck,tubesm,rowsm

C Begin subroutine
      Do i=1,ntt

c	initialize surf and surft arrays

	surf(i)=0.0
	surft(i)=0.0

C	now find the average z value
         if (headtub(i).gt.0) then

         sumz=0.0
         m=0
         Do j=headtub(i),1,-1
            m=m+1
            If (m.GT.numpart) goto 72
            sumz=sumz+zr(tublist(j,i))
         End do
 72      continue
         surft(i)=sumz/real(m)
	end if
      End do

	go to 69


C	Boxcar smooth surft array. The limits are hardcoded to include all
c	adjacent boxes.

	do i=2,tubmax-1
	 rowct=(i-1)*tubmax
	 do j=2,tubmax-1
	  tubeck=rowct+j
	  if(headtub(tubeck).gt.0) then
	   sumz=0.0
	   m=0
	   do ii=i-1,i+1
	    rowsm=(ii-1)*tubmax
	    do jj=j-1,j+1
	     tubesm=rowsm+jj
	     if(headtub(tubesm).gt.0) then
	      sumz=sumz+surft(tubesm)
	      m=m+1
	     end if
	    end do
	   end do
	   surf(tubeck)=sumz/real(m)
	  end if
	 end do
	end do

69	continue

      Return
      End




