C     Programmer:Chris Burke
C     Date: June 9, 1997
C     Purpose:  Take particle positions and their temperatures from 
C     Dr. Simpson's Jdisk IBWD accretion disk simulation, rotate positions
C     to viewing position using eulerian angles.  Put particles into a grid
C     of sight tubes parallel to the y-axis.  Then select the first particles
C     in each sight tube to make light curve.

      Subroutine tube

C Declare variables
      implicit none
      include 'comblock'
      include 'tubecom'
      integer i

C Begin Subroutine

C Get angles for transformation
      Do anglei=1,angles
         phi=phiaf(anglei)
         theta=thetaaf(anglei)
         psi=psiaf(anglei)
C Rotate particles to viewing angle and find out which tube they are in.
         call assignt
C sort tubes according to z values
         call sortt
C Get surface using particles above avgz(i)
         call surface
C Find normals for tube
         call norms
C Find the overall u,b,v,r,i sums from all particles
         call mags
      End do

C Write out ux magnitudes

      Open (80,File='UX.filt',Status='old',access='append')
      write(80,23) (valux(i),i=1,angles)
 23   format(9(1x,f9.5))
      Close (80)

C Write out bx magnitudes

      Open (81,File='BX.filt',status='old',access='append')
      write(81,23) (valbx(i),i=1,angles)
      close (81)

C Write out b magnitudes

      Open (82,File='B.filt',status='old',access='append')
      write(82,23) (valb(i),i=1,angles)
      close (82)

C Write out v magnitudes

      Open (83,File='V.filt',status='old',access='append')
      write(83,23) (valv(i),i=1,angles)
      close (83)

C Write out r magnitudes

      Open (84,File='R.filt',status='old',access='append')
      write(84,23) (valr(i),i=1,angles)
      close (84)

C Write out i magnitudes

      Open (85,File='I.filt',status='old',access='append')
      write(85,23) (vali(i),i=1,angles)
      close (85)

C Write out # of tubes

      Open (86,File='NUM.tubes',status='old',access='append')
      Do i=1,angles-1
         write(86,25) tubcnt(i)
 25      format(1x,i9,$)
      End do
26    format(1x,i9)
      write(86,26) tubcnt(angles)
      close (86)

C Write out # of particles

      Open (87,File='NUM.part',status='old',access='append')
      Do i=1,angles-1
         write(87,25) partcnt(i)
      End do
      write(87,26) partcnt(angles)
      close (87)

      Return
      End
